<?php

//Customizer

class sturdy_customize {

//Load Defaults

 public static function sturdy_customizer_register($wp_customize) {

    	$sturdy_defaults = array(
		
		'background_color_choice' => '#232323',
		'header_color_choice' => '#e80000',
		'header_font_color_choice' => '#ffffff',
		'subheader_color_choice' => '#f9f9f9',
		'subheader_font_color_choice' => '#000000',
		'topbar_color_choice' => '#000000',
		'topbar_font_color_choice' => '#ffffff',
		'footer_color_choice' => '#e60000',
		'footer_font_color_choice' => '#d1d1d1',
		'category_hover_color_choice' => '#0a0402',
		'category_color_choice' => '#0027b5',
		'post_title_color_choice' => '#00010f',
		'color_option' => 'color_option_one',
		'post_font_choice' => 'Helvetica, Arial',
		'post_font_color_choice' => '#0a0101',
		'post_font_size_choice' => '17px',
		'post_font_weight_choice' => 'normal',
		'menu_font_choice' => 'Helvetica, Arial',
		'menu_font_size_choice' => '12px',
		'menu_font_weight_choice' => 'bold',
		'logo_font_choice' => 'Helvetica, Arial',
		'logo_font_color_choice' => '#ffffff',
		'logo_font_size_choice' => '30px',
		'logo_font_weight_choice' => 'bold',
		'logo_background_width_choice' => '30%%',
		'tagline_font_choice' => 'Roboto Slab, Arial',
		'tagline_font_color_choice' => '#ffffff',
		'tagline_font_size_choice' => '19px',
		'tagline_font_weight_choice' => 'normal',
		'homelayout_choice' => 'col-3cm',
		'postslayout_choice' => 'col-3cm',
		'carousel_image_border_color' => '#fff',
		'related_post_display' => 'cats',
		'carousel_post_title_color' => '#fff',
		'carousel_post_title_hover_color' => '#46B2FF',
		'home_image_border_color' => '#000',
		'featured_post_category' => '1',
		'logo_border_color_choice' => '#fff',
		'logo_background_color_choice' => '#e80000'
	);

	$wp_customize->add_panel('color_panel', array(
		'title'=>__('Theme Colors and Background', 'sturdy'),
		'description' => __('Use a background image instead of a color.', 'sturdy')

	     ));

	// Background color and image

	$wp_customize->add_section('background_image', array(
			'title'=>__('Background Image and Color', 'sturdy'),
			'description' => __('Change your background color or display an image instead.', 'sturdy'),
			'panel' => 'color_panel'
		));

	$wp_customize->add_setting('background_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['background_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'background_color_choice', array(
			'label'=>__('Background Color','sturdy'),
			'section' => 'background_image',
			'priority' => 1
		)));

	 // Menu and menu font color options

	$wp_customize->add_section('menu_colors', array(
			'title'=>__('Menu Colors', 'sturdy'),
			'description' => __('Change your menu background colors.', 'sturdy'),
			'panel' => 'color_panel'
		));

	$wp_customize->add_setting('topbar_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['topbar_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'topbar_color_choice', array(
			'label'=>__('Topbar Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 1
		) ));

	$wp_customize->add_setting('topbar_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['topbar_font_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

     $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'topbar_font_color_choice', array(
			'label'=>__('Topbar Font Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 2

		) ));
   
	$wp_customize->add_setting('logo_border_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_border_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

     $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'logo_border_color_choice', array(
			'label'=>__('Logo Border Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 3

		) ));
	
	$wp_customize->add_setting('logo_background_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_background_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

     $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'logo_background_color_choice', array(
			'label'=>__('Logo Background Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 4

		) ));
     

    $wp_customize->add_setting('header_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['header_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'header_color_choice', array(
			'label'=>__('Header Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 5
	    ) ));

	$wp_customize->add_setting('header_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['header_font_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'header_font_color_choice', array(
			'label'=>__('Header Font Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 6

		) ));

    $wp_customize->add_setting('subheader_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['subheader_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'subheader_color_choice', array(
			'label'=>__('Subheader Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 7
		)));
	
	$wp_customize->add_setting('subheader_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['subheader_font_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'subheader_font_color_choice', array(
			'label'=>__('Subheader Font Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 8

		) ));



	$wp_customize->add_setting('footer_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['footer_color_choice'],
            'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'footer_color_choice', array(
			'label'=>__('Footer Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 9
		) ));

	$wp_customize->add_setting('footer_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['footer_font_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));
		   
     $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'footer_font_color_choice', array(
			'label'=>__('Footer Font Color','sturdy'),
			'section' => 'menu_colors',
			'priority' => 10

		) ));

		// Link and hover colors

	$wp_customize->add_section('sturdy_link_colors', array(
			'title'=>__('Link Colors', 'sturdy'),
			'description' => __('Change link colors.', 'sturdy'),
			'panel' => 'color_panel'
		));
	

    $wp_customize->add_setting('category_hover_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['category_hover_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

		));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'category_hover_color_choice', array(
			'label'=>__('Change Category and Comment Link Hover Color','sturdy'),
			'section' => 'sturdy_link_colors'
		) ));

	$wp_customize->add_setting('category_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['category_color_choice'],
	        'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'category_color_choice', array(
			'label'=>__('Change Category Link Color','sturdy'),
			'section' => 'sturdy_link_colors'
		) ));

		// Color schemes

	$wp_customize->add_section('color_schemes', array(
			'title'=>__('Color Schemes', 'sturdy'),
			'description' => __('Choose a premade color scheme.', 'sturdy'),
			'panel' => 'color_panel'
	    ));
		    
	$wp_customize->add_setting('color_option', array(
			'default' => $sturdy_defaults['color_option'],
		    'transport' => 'postMessage',
		   	'sanitize_callback' => 'sturdy_sanitize_color_option'
		));


	$wp_customize->add_control('color_option', array(
			'label'=>__('Color Scheme','sturdy'),
			'section' => 'color_schemes',
			'type' => 'radio',
			'choices' => array(
				'color_option_one' => __('Energy','sturdy'),
				'color_option_two' => __('Calm','sturdy')
				)
			
			
		 )); 

	$wp_customize->add_setting('edit_scheme', array(
		   	'default' => 1,
		   	'transport' => 'postMessage',
		    'sanitize_callback' => 'sturdy_sanitize_checkbox' 

		 ));


	$wp_customize->add_control('edit_scheme', array(
			'label'=>__('Modify Scheme','sturdy'),
			'description' => __('After changing your color scheme, you must click Save & Publish with this box <b>unchecked</b> for it to be applied.<br><br> Select this checkbox if you wish to edit your current color scheme <b>after it has been saved</b>.<br><br> If left unchecked, any custom changes you make will be lost when you refresh the page.', 'sturdy'),
			'section' => 'color_schemes',
			'type' => 'checkbox'
			
			
	     ));
	

		    	// Site info and logo


	 $wp_customize->add_section('title_tagline', array(
			'title' =>__('Site Info and Logo', 'sturdy'),
			'priority' => 1
			
  			));
		    	
 	 $wp_customize->add_setting('logo_image', array(
			'transport' => 'refresh',
			'sanitize_callback' => 'esc_url_raw'
			));

	 $wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, 'logo_image', array(
			'label'=>__('Change Logo','sturdy'),
			'section' => 'title_tagline',
			'priority' => 11
		    )));

	 // Theme Info

     $wp_customize->add_setting('theme_info', array('sanitize_callback' => 'sanitize_text_field'));

	 require_once dirname(__FILE__) . '/theme-info-custom-control.php';

	 $wp_customize->add_control( new Sturdy_Info_Custom_Control($wp_customize, 'theme_info', array(
			'label'=>__('Theme Info','sturdy'),
			'section' => 'title_tagline',
			'priority' => 15
		  
		    )));

	    // Copyright section
		
	$wp_customize->add_setting('copyright_text', array(
			'default'=>'',
			'transport' => 'postMessage',
			'sanitize_callback' => 'sturdy_sanitize_text'
			));


	$wp_customize->add_control( 'copyright_text', array(
			'label'=>__('Change Footer Copyright info','sturdy'),
			'section' => 'title_tagline',
			'priority' => 10
		    ));

		    // Main column header text
		
	$wp_customize->add_setting('main_column_text', array(
			'default'=>__('Welcome!', 'sturdy'),
			'transport' => 'postMessage',
			'sanitize_callback' => 'sturdy_sanitize_text'
			));


	$wp_customize->add_control( 'main_column_text', array(
			'label'=>__('Change Main Column Text','sturdy'),
			'section' => 'title_tagline',
			'priority' => 10
		    ));

		      // Fonts section

    $wp_customize->add_panel('sturdy_fonts', array(
			'title' =>__('Fonts', 'sturdy'),
			'description' => __('Change your fonts and their colors.', 'sturdy')
  			));

            // Post fonts

    $wp_customize->add_section('post_font', array(
			'title'=>__('Post Font', 'sturdy'),
			'description' => __('Change the font of your posts.', 'sturdy'),
			'panel' => 'sturdy_fonts'
	    	));
		

    $wp_customize->add_setting('post_font_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['post_font_choice'],
			'sanitize_callback' => 'sturdy_sanitize_fonts'
			
			));


	$wp_customize->add_control( 'post_font_choice', array(
			'label'=>__('Post Font','sturdy'),
			'section' => 'post_font',
			'type' => 'select',
			'choices' => array(
				'Roboto Slab, Arial' => __('Roboto Slab','sturdy'),
				'Open Sans, Arial' => __('Open Sans','sturdy'),
				'Helvetica, Arial' => __('Helvetica','sturdy'),
				'McLaren, Arial' => __('McLaren','sturdy')

		    )));

		    		
	$wp_customize->add_setting('post_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['post_font_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'post_font_color_choice', array(
			'label'=>__('Change Post Font Color','sturdy'),
			'section' => 'post_font'
	
			) ));

	$wp_customize->add_setting('post_title_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['post_title_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

		));

	$wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'post_title_color_choice', array(
			'label'=>__('Change Post Title Color','sturdy'),
			'section' => 'post_font'
		)));
			             		

	$wp_customize->add_setting('post_font_size_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['post_font_size_choice'],
		    'sanitize_callback' => 'sturdy_size_sanitize'
	
			));
		   
	 $wp_customize->add_control('post_font_size_choice', array(
			'label'=>__('Change Post Font Size','sturdy'),
			'section' => 'post_font',
			'type' => 'select',
			'choices' => array(
				'15px' => __('Small','sturdy'),
				'17px' => __('Medium','sturdy'),
				'19px' => __('Large','sturdy'),
				'21px' => __('Extra Large','sturdy')
			 ) ));
			           

     $wp_customize->add_setting('post_font_weight_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['post_font_weight_choice'],
			'sanitize_callback' => 'sturdy_weight_sanitize'
			));
		   
	 $wp_customize->add_control('post_font_weight_choice', array(
			'label'=>__('Change Post Font Weight','sturdy'),
			'section' => 'post_font',
			'type' => 'select',
			'choices' => array(
				'normal' => __('Normal','sturdy'),
				'bold' => __('Bold','sturdy')

			) ) );

		           // Menu fonts
		   

	 $wp_customize->add_section('menu_font', array(
			'title'=>__('Menu Font', 'sturdy'),
			'description' => __('Change the font of your menus.', 'sturdy'),
			'panel' => 'sturdy_fonts'
	    	));

	 $wp_customize->add_setting('menu_font_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['menu_font_choice'],
			'sanitize_callback' => 'sturdy_sanitize_fonts'
			
			));


	 $wp_customize->add_control( 'menu_font_choice', array(
			'label'=>__('Menu Fonts','sturdy'),
			'section' => 'menu_font',
			'type' => 'select',
			'choices' => array(
				'Roboto Slab, Arial' => __('Roboto Slab','sturdy'),
				'Open Sans, Arial' => __('Open Sans','sturdy'),
				'Helvetica, Arial' => __('Helvetica','sturdy'),
				'McLaren, Arial' => __('McLaren','sturdy')
 			)));
		

	 $wp_customize->add_setting('menu_font_size_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['menu_font_size_choice'],
			'sanitize_callback' => 'sturdy_menu_size_sanitize'
		));
		   
	$wp_customize->add_control('menu_font_size_choice', array(
			'label'=>__('Change Menu Font Size','sturdy'),
			'section' => 'menu_font',
			'type' => 'select',
			'choices' => array(
				'11px' => __('Small','sturdy'),
				'12px' => __('Medium','sturdy'),
				'13px' => __('Large','sturdy'),
				'14px' => __('Extra Large','sturdy')
		 ) ));
		           
	 $wp_customize->add_setting('menu_font_weight_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['menu_font_weight_choice'],
			'sanitize_callback' => 'sturdy_weight_sanitize'

		));
		   
    $wp_customize->add_control('menu_font_weight_choice', array(
			'label'=>__('Change Menu Font Weight','sturdy'),
			'section' => 'menu_font',
			'type' => 'select',
			'choices' => array(
				'normal' => __('Normal','sturdy'),
				'bold' => __('Bold','sturdy')
		 ) ));

		          // Logo

	$wp_customize->add_section('logo_font', array(
			'title'=>__('Logo Font', 'sturdy'),
			'description' => __('Change your logo font (if not using an image).', 'sturdy'),
			'panel' => 'sturdy_fonts'
	    	));

	$wp_customize->add_setting('logo_font_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_font_choice'],
			'sanitize_callback' => 'sturdy_sanitize_fonts'
			
			));


	 $wp_customize->add_control( 'logo_font_choice', array(
			'label'=>__('Logo Font','sturdy'),
			'section' => 'logo_font',
			'type' => 'select',
			'choices' => array(
				'Roboto Slab, Arial' => __('Roboto Slab','sturdy'),
				'Open Sans, Arial' => __('Open Sans','sturdy'),
				'Helvetica, Arial' => __('Helvetica','sturdy'),
				'McLaren, Arial' => __('McLaren','sturdy')
 			)));

		    		

     $wp_customize->add_setting('logo_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_font_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
	 $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'logo_font_color_choice', array(
			'label'=>__('Change Logo Font Color','sturdy'),
			'section' => 'logo_font',
			) ));
            		

	 $wp_customize->add_setting('logo_font_size_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_font_size_choice'],
	        'sanitize_callback' => 'sturdy_logo_size_sanitize'
			));
		   
	 $wp_customize->add_control('logo_font_size_choice', array(
			'label'=>__('Change Logo Font Size','sturdy'),
			'section' => 'logo_font',
			'type' => 'select',
			'choices' => array(
				'30px' => __('Small','sturdy'),
				'36px' => __('Medium','sturdy'),
				'42px' => __('Large','sturdy'),
				'48px' => __('Extra Large','sturdy')
			 ) ));


     $wp_customize->add_setting('logo_font_weight_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_font_weight_choice'],
			'sanitize_callback' => 'sturdy_weight_sanitize'

			));
		 
     $wp_customize->add_control('logo_font_weight_choice', array(
			'label'=>__('Change Logo Font Weight','sturdy'),
			'section' => 'logo_font',
			'type' => 'select',
			'choices' => array(
				'normal' => __('Normal','sturdy'),
				'bold' => __('Bold','sturdy')
			 ) ));
    
     $wp_customize->add_setting('logo_background_width_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['logo_background_width_choice'],
			'sanitize_callback' => 'sturdy_width_sanitize'

			));
		 
     $wp_customize->add_control('logo_background_width_choice', array(
			'label'=>__('Change Logo Background Width','sturdy'),
			'section' => 'logo_font',
			'type' => 'select',
			'choices' => array(
				'20%' => '20%',
				'30%' => '30%',
				'40%' => '40%',
				'50%' => '50%',
				'60%' => '60%')
			 ) );

           // Tagline

	$wp_customize->add_section('tagline_font', array(
			'title'=>__('Tagline Font', 'sturdy'),
			'description' => __('Tagline font options.', 'sturdy'),
			'panel' => 'sturdy_fonts'
	    	));

    $wp_customize->add_setting('tagline_font_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['tagline_font_choice'],
			'sanitize_callback' => 'sturdy_sanitize_fonts'
			
			));


	 $wp_customize->add_control( 'tagline_font_choice', array(
			'label'=>__('Tagline Font','sturdy'),
			'section' => 'tagline_font',
			'type' => 'select',
			'choices' => array(
				'Roboto Slab, Arial' => __('Roboto Slab','sturdy'),
				'Open Sans, Arial' => __('Open Sans','sturdy'),
				'Helvetica, Arial' => __('Helvetica','sturdy'),
				'McLaren, Arial' => __('McLaren','sturdy')

 			)));
		    		

	 $wp_customize->add_setting('tagline_font_color_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['tagline_font_color_choice'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
	 $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'tagline_font_color_choice', array(
			'label'=>__('Change Tagline Font Color','sturdy'),
			'section' => 'tagline_font',
			)  ) );
		             		

     $wp_customize->add_setting('tagline_font_size_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['tagline_font_size_choice'],
			'sanitize_callback' => 'sturdy_size_sanitize'
			));
		   
	 $wp_customize->add_control('tagline_font_size_choice', array(
			'label'=>__('Change Tagline Font Size','sturdy'),
			'section' => 'tagline_font',
			'type' => 'select',
			'choices' => array(
				'15px' => __('Small','sturdy'),
				'17px' => __('Medium','sturdy'),
				'19px' => __('Large','sturdy'),
				'21px' => __('Extra Large','sturdy'),
			 ) ) );


	 $wp_customize->add_setting('tagline_font_weight_choice', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['tagline_font_weight_choice'],
			'sanitize_callback' => 'sturdy_weight_sanitize'

			));
		   
	 $wp_customize->add_control('tagline_font_weight_choice', array(
			'label'=>__('Change Tagline Font Weight','sturdy'),
			'section' => 'tagline_font',
			'type' => 'select',
			'choices' => array(
				'normal' => __('Normal','sturdy'),
				'bold' => __('Bold','sturdy'),
				) ) );

		    // Layout options

		
	 $wp_customize->add_setting('homelayout_choice', array(
			'default' => $sturdy_defaults['homelayout_choice'],
			'sanitize_callback' => 'sturdy_sanitize_layout'

			));

	 $wp_customize->add_control( 'homelayout_choice', array(
			'label'=>__('Homepage Layout','sturdy'),
			'section' => 'static_front_page',
			'type' => 'select',
			'active_callback' => 'is_front_page',
			'choices' => array(
				'col-1c full-width-content' => __('Full Width Content','sturdy'),
				'col-2cl' => __('One Sidebar On The Right','sturdy'),
				'col-2cr' => __('One Sidebar On The Left','sturdy'),
				'col-3cm' => __('Two Sidebars with the Content Center','sturdy')
				) ));

	 $wp_customize->add_setting('postslayout_choice', array(
			'default' => $sturdy_defaults['postslayout_choice'],
			'sanitize_callback' => 'sturdy_sanitize_layout'
			
			));

	 $wp_customize->add_control( 'postslayout_choice', array(
			'label'=>__('Posts Layout','sturdy'),
			'section' => 'static_front_page',
			'type' => 'select',
			'active_callback' => 'is_post_page',
			'choices' => array(
				'col-1c full-width-content' => __('Full Width Content','sturdy'),
				'col-2cl' => __('One Sidebar On The Right','sturdy'),
				'col-2cr' => __('One Sidebar On The Left','sturdy'),
				'col-3cm' => __('Two Sidebars with the Content Center','sturdy')
 				) ));

		    	// Featured posts


$wp_customize->add_panel('sturdy_featured', array(
			'title' =>__('Carousel, Featured, and Related Posts', 'sturdy'),
			'description' => __('Change your featured post settings.', 'sturdy')
  			));

            // Post fonts

    $wp_customize->add_section('featured_post_settings', array(
			'title'=>__('Carousel Post Category Settings', 'sturdy'),
			'description' => __('Change the category of posts displayed in the carousel.', 'sturdy'),
			'panel' => 'sturdy_featured'
	    	));
		

    // Custom Control from Paulund at https://github.com/paulund/wordpress-theme-customizer-custom-controls
    require_once dirname(__FILE__) . '/category-dropdown-custom-control.php';

    $wp_customize->add_setting('featured_post_category', array(
			'default' => $sturdy_defaults['featured_post_category'],
			'sanitize_callback' => 'absint'
			));
		   
    $wp_customize->add_control( new Category_Dropdown_Custom_Control($wp_customize, 'featured_post_category', array(
			'label'=>__('Change Carousel Post Category','sturdy'),
			'section' => 'featured_post_settings'
	
			) ));

    // Related Post options
  
    $wp_customize->add_section('related_posts', array(
			'title'=>__('Related Post Source', 'sturdy'),
			'description' => __('Change what kind of related posts are shown.', 'sturdy'),
			'panel' => 'sturdy_featured'
	    	));
		    		
	$wp_customize->add_setting('related_post_display', array(
 			'default' => $sturdy_defaults['related_post_display'],
		    'sanitize_callback' => 'sturdy_related_sanitize'

			));
		   
    $wp_customize->add_control('related_post_display', array(
			'section' => 'related_posts',
			'type' => 'radio',
			'choices' => array(
				'cats' => __('Related by Category','sturdy'),
				'tags' => __('Related by Tags','sturdy'),
			) ) );

    // Carousel and image border colors

    $wp_customize->add_section('featured_post_colors', array(
			'title'=>__('Border and Title Color', 'sturdy'),
			'description' => __('Change the border and carousel post title colors.', 'sturdy'),
			'panel' => 'sturdy_featured'
	    	));
		    		
	$wp_customize->add_setting('carousel_image_border_color', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['carousel_image_border_color'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'carousel_image_border_color', array(
			'label'=>__('Carousel Image Border Color','sturdy'),
			'section' => 'featured_post_colors',
			'priority' => 1
			) ));

	$wp_customize->add_setting('carousel_post_title_color', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['carousel_post_title_color'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'carousel_post_title_color', array(
			'label'=>__('Carousel Post Title Color','sturdy'),
			'section' => 'featured_post_colors',
			'priority' => 3	
			) ));

	$wp_customize->add_setting('carousel_post_title_hover_color', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['carousel_post_title_hover_color'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'carousel_post_title_hover_color', array(
			'label'=>__('Carousel Post Title Hover Color','sturdy'),
			'section' => 'featured_post_colors',
			'priority' => 4	
			) ));

	$wp_customize->add_setting('home_image_border_color', array(
			'transport' => 'postMessage',
			'default' => $sturdy_defaults['home_image_border_color'],
		    'sanitize_callback' => 'sanitize_hex_color'

			));
		   
    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'home_image_border_color', array(
			'label'=>__('Featured Images Border Color','sturdy'),
			'section' => 'featured_post_colors',
			'priority' => 2
	
			) ));


		    	// Remove defaults
		    		
    $wp_customize->remove_section('colors');
	$wp_customize->remove_section('header_image');
	$wp_customize->remove_control('display_header_text', array('section' => 'title_tagline'));

		    	// Add to defaults

    $wp_customize->get_section( 'static_front_page' )-> title = __( 'Layout Options', 'sturdy' );
    $wp_customize->get_control( 'show_on_front' )->active_callback = 'is_front_page';
	$wp_customize->get_setting( 'blogname' )->transport = 'postMessage';
    $wp_customize->get_setting( 'blogdescription' )->transport = 'postMessage'; 
    $wp_customize->get_control( 'site_icon' )->priority = '13'; 


}


// CSS Output
   public static function sturdy_header_css_output() {
     
     	$sturdy_defaults = array(
		
		'background_color_choice' => '#232323',
		'header_color_choice' => '#e80000',
		'header_font_color_choice' => '#ffffff',
		'subheader_color_choice' => '#f9f9f9',
		'subheader_font_color_choice' => '#000000',
		'topbar_color_choice' => '#000000',
		'topbar_font_color_choice' => '#ffffff',
		'footer_color_choice' => '#e60000',
		'footer_font_color_choice' => '#d1d1d1',
		'category_hover_color_choice' => '#0a0402',
		'category_color_choice' => '#0027b5',
		'post_title_color_choice' => '#00010f',
		'color_option' => 'color_option_one',
		'post_font_choice' => 'Helvetica, Arial',
		'post_font_color_choice' => '#0a0101',
		'post_font_size_choice' => '17px',
		'post_font_weight_choice' => 'normal',
		'menu_font_choice' => 'Helvetica, Arial',
		'menu_font_size_choice' => '12px',
		'menu_font_weight_choice' => 'bold',
		'logo_font_choice' => 'Helvetica, Arial',
		'logo_font_color_choice' => '#ffffff',
		'logo_font_size_choice' => '30px',
		'logo_font_weight_choice' => 'bold',
		'logo_background_width_choice' => '30%%',
		'tagline_font_choice' => 'Roboto Slab, Arial',
		'tagline_font_color_choice' => '#ffffff',
		'tagline_font_size_choice' => '19px',
		'tagline_font_weight_choice' => 'normal',
		'homelayout_choice' => 'col-3cm',
		'postslayout_choice' => 'col-3cm',
		'carousel_image_border_color' => '#fff',
		'related_post_display' => 'cats',
		'carousel_post_title_color' => '#fff',
		'carousel_post_title_hover_color' => '#46B2FF',
		'home_image_border_color' => '#000',
		'featured_post_category' => '1',
		'logo_border_color_choice' => '#fff',
		'logo_background_color_choice' => '#e80000'
	
	); 
     
      ?>


      <!--Customizer CSS--> 
      <style type="text/css">


              <?php self::sturdy_generate_css('body', 'background', 'background_color_choice', $sturdy_defaults['background_color_choice']); ?>

              <?php self::sturdy_generate_css('.home .content .post-title a, h1.post-title', 'color', 'post_title_color_choice', $sturdy_defaults['post_title_color_choice']); ?>

              <?php self::sturdy_generate_css('.post-category a, .post-comments a, .tab-item-category a', 'color', 'category_color_choice', $sturdy_defaults['category_color_choice']); ?>

              <?php self::sturdy_generate_css('.post-category a:hover, .post-comments a:hover, .tab-item-category a:hover', 'color', 'category_hover_color_choice', $sturdy_defaults['category_hover_color_choice']); ?>

              <?php self::sturdy_generate_css('.post', 'font-weight', 'post_font_weight_choice', $sturdy_defaults['post_font_weight_choice']); ?>

              <?php self::sturdy_generate_css('.post, .entry.excerpt', 'color', 'post_font_color_choice', $sturdy_defaults['post_font_color_choice']); ?>

              <?php self::sturdy_generate_css('.post', 'font-family', 'post_font_choice', $sturdy_defaults['post_font_choice']); ?>

              <?php self::sturdy_generate_css('.entry', 'font-size', 'post_font_size_choice', $sturdy_defaults['post_font_size_choice']); ?>

              <?php self::sturdy_generate_css('#nav-header, #nav-subheader , #nav-footer, #nav-topbar', 'font-weight', 'menu_font_weight_choice', $sturdy_defaults['menu_font_weight_choice']); ?> 

              <?php self::sturdy_generate_css('#nav-header div ul li a, #nav-subheader, #nav-footer, #nav-topbar', 'font-size', 'menu_font_size_choice', $sturdy_defaults['menu_font_size_choice']); ?>

              <?php self::sturdy_generate_css('#nav-header, #nav-subheader , #nav-footer, #nav-topbar', 'font-family', 'menu_font_choice', $sturdy_defaults['menu_font_choice']); ?> 

              <?php self::sturdy_generate_css('#nav-header, #nav-header .menu-item, a.sidebar-toggle, #nav-header .nav-wrap', 'background', 'header_color_choice', $sturdy_defaults['header_color_choice']); ?>

              <?php self::sturdy_generate_css('#nav-subheader, #nav-subheader .menu-item, #nav-subheader .nav-wrap', 'background', 'subheader_color_choice', $sturdy_defaults['subheader_color_choice']); ?>

              <?php self::sturdy_generate_css('#nav-footer, #nav-footer .menu-item', 'background', 'footer_color_choice', $sturdy_defaults['footer_color_choice']); ?> 

              <?php self::sturdy_generate_css('#nav-topbar, #nav-topbar .menu-item', 'background', 'topbar_color_choice', $sturdy_defaults['topbar_color_choice']); ?> 

              <?php self::sturdy_generate_css('#nav-topbar .nav li a, #nav-topbar div', 'color', 'topbar_font_color_choice', $sturdy_defaults['topbar_font_color_choice']); ?>

              <?php self::sturdy_generate_css('#nav-header .nav li a, #nav-header div', 'color', 'header_font_color_choice', $sturdy_defaults['header_font_color_choice']); ?>

              <?php self::sturdy_generate_css('#nav-subheader .nav li a, #nav-subheader div', 'color', 'subheader_font_color_choice', $sturdy_defaults['subheader_font_color_choice']); ?>

              <?php self::sturdy_generate_css('#nav-footer .nav li a, #nav-footer div ', 'color', 'footer_font_color_choice', $sturdy_defaults['footer_font_color_choice']); ?>

     	      <?php self::sturdy_generate_css('.site-title a', 'font-size', 'logo_font_size_choice', $sturdy_defaults['logo_font_size_choice']); ?> 

    	      <?php self::sturdy_generate_css('.site-title a', 'color', 'logo_font_color_choice', $sturdy_defaults['logo_font_color_choice']); ?> 

      	      <?php self::sturdy_generate_css('.site-title', 'font-family', 'logo_font_choice', $sturdy_defaults['logo_font_choice']); ?> 

      	      <?php self::sturdy_generate_css('.site-title a', 'font-weight', 'logo_font_weight_choice', $sturdy_defaults['logo_font_weight_choice']); ?> 
      	     
      	      <?php self::sturdy_generate_css('.site-title', 'width', 'logo_background_width_choice', $sturdy_defaults['logo_background_width_choice']); ?> 

     	      <?php self::sturdy_generate_css('.site-title', 'border-color', 'logo_border_color_choice', $sturdy_defaults['logo_border_color_choice']); ?> 

              <?php self::sturdy_generate_css('.site-title', 'background', 'logo_background_color_choice', $sturdy_defaults['logo_background_color_choice']); ?>

     	      <?php self::sturdy_generate_css('.site-descriptionh', 'font-family', 'tagline_font_choice', $sturdy_defaults['tagline_font_choice']); ?>

              <?php self::sturdy_generate_css('.site-descriptionh', 'color', 'tagline_font_color_choice', $sturdy_defaults['tagline_font_color_choice']); ?>

              <?php self::sturdy_generate_css('.site-descriptionh', 'font-size', 'tagline_font_size_choice', $sturdy_defaults['tagline_font_size_choice']); ?>
                           
              <?php self::sturdy_generate_css('.site-descriptionh', 'font-weight', 'tagline_font_weight_choice', $sturdy_defaults['tagline_font_weight_choice']); ?>

              <?php self::sturdy_generate_css('.featuredclip rect', 'fill', 'carousel_image_border_color', $sturdy_defaults['carousel_image_border_color']); ?>
                           
              <?php self::sturdy_generate_css('.mainclip rect', 'fill', 'home_image_border_color', $sturdy_defaults['home_image_border_color']); ?>

              <?php self::sturdy_generate_css('.featured-posts .post-title a', 'color', 'carousel_post_title_color', $sturdy_defaults['carousel_post_title_color']); ?>

              <?php self::sturdy_generate_css('.featured-posts .post-title a:hover', 'color', 'carousel_post_title_hover_color', $sturdy_defaults['carousel_post_title_hover_color']); ?>

   
      </style> 
      <!--/Customizer CSS-->
      <?php

   }


//ENQUEUE JAVASCRIPT FOR LIVE PREVIEW
   public static function sturdy_live_preview() {
      wp_enqueue_script( 
           'sturdy-themecustomizer', get_template_directory_uri() . '/js/theme-customizer.js', array(  'jquery', 'customize-preview' ), '', true );
  	 }

 //CSS OUTPUT FUNCTION DECLARATION
    public static function sturdy_generate_css( $selector, $style, $mod_name, $default, $prefix='', $postfix='', $echo=true ) {
      $return = '';
      $mod = get_theme_mod($mod_name, $default);
      if ( ! empty( $mod ) ) {
         $return = sprintf('%s { %s:%s; }',
            $selector,
            $style,
            $prefix.$mod.$postfix
         );
         if ( $echo ) {
            echo $return;
         }
      }
      return $return;
    }

}

/**
 * This function adds some styles to the WordPress Customizer
 */
function sturdy_customizer_styles() { ?>
  
    <style>

	/* Setting dividers */

	#customize-control-topbar_font_color_choice { padding-bottom: 10px; border-bottom: 1px black solid;}

	#customize-control-logo_background_color_choice {padding-bottom: 10px; border-bottom: 1px black solid;}

	#customize-control-header_font_color_choice {padding-bottom: 10px; border-bottom: 1px black solid;}

	#customize-control-subheader_font_color_choice {padding-bottom: 10px; border-bottom: 1px black solid;}

    
    </style>
    
    <?php

}

add_action( 'customize_controls_print_styles', 'sturdy_customizer_styles', 999 );
add_action( 'wp_head' , array( 'sturdy_customize' , 'sturdy_header_css_output' ) );
add_action( 'customize_register' , array( 'sturdy_customize' , 'sturdy_customizer_register' ) );
add_action( 'customize_preview_init' , array( 'sturdy_customize' , 'sturdy_live_preview' ) );


//Customizer sanitization callback functions

function sturdy_sanitize_text( $input ) {
    return wp_kses_post( force_balance_tags( $input ) );
}

function sturdy_related_sanitize( $input ) {
    $valid = array(
				'cats' => __('Related by Category','sturdy'),
				'tags' => __('Related by Tags','sturdy'),
    );
 
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_sanitize_layout( $input ) {
    $valid = array(
				'col-1c full-width-content' => __('Full Width Content','sturdy'),
				'col-2cl' => __('One Sidebar On The Right','sturdy'),
				'col-2cr' => __('One Sidebar On The Left','sturdy'),
				'col-3cm' => __('Two Sidebars with the Content Center','sturdy')
    );
 
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_sanitize_fonts( $input ) {
	$valid = array(
				'Roboto Slab, Arial' => __('Roboto Slab','sturdy'),
				'Open Sans, Arial' => __('Open Sans','sturdy'),
				'Helvetica, Arial' => __('Helvetica','sturdy'),
				'McLaren, Arial' => __('McLaren','sturdy')
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_featured_sanitize( $input ) {
	$valid = array(
				'5' => '5',
				'10' => '10',
				'15' => '15'
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_weight_sanitize( $input ) {
	$valid = array(
				'normal' => __('Normal','sturdy'),
				'bold' => __('Bold','sturdy')
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_width_sanitize( $input ) {
	$valid = array(
				'30%' => '30%',
				'20%' => '20%',
				'40%' => '40%',
				'50%' => '50%',
				'60%' => '60%'
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_size_sanitize( $input ) {
	$valid = array(
				'15px' => __('Small','sturdy'),
				'17px' => __('Medium','sturdy'),
				'19px' => __('Large','sturdy'),
				'21px' => __('Extra Large','sturdy')
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_menu_size_sanitize( $input ) {
	$valid = array(
				'11px' => __('Small','sturdy'),
				'12px' => __('Medium','sturdy'),
				'13px' => __('Large','sturdy'),
				'14px' => __('Extra Large','sturdy')
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}
    
 function sturdy_logo_size_sanitize( $input ) {
	$valid = array(
				'30px' => __('Small','sturdy'),
				'36px' => __('Medium','sturdy'),
				'42px' => __('Large','sturdy'),
				'48px' => __('Extra Large','sturdy')
				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

 function sturdy_sanitize_color_option( $input ) {
	$valid = array(
				'color_option_one' => __('Energy','sturdy'),
				'color_option_two' => __('Calm','sturdy')

				);

    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

function sturdy_sanitize_checkbox( $input ) {
    if ( $input == 1 ) {
        return 1;
    } else {
        return '';
    }
}

// Post layout control active callback
function is_post_page() {
	return is_single();
}