/*
	scripts.js
	
	License: GNU General Public License v3.0
	License URI: http://www.gnu.org/licenses/gpl-3.0.html
	
	
*/

"use strict";

jQuery(document).ready(function($) {

/*  Toggle header search
/* ------------------------------------ */
	$('.toggle-search').click(function(){
		$('.toggle-search').toggleClass('active');
		$('.search-expand').fadeToggle(250);
            setTimeout(function(){
                $('.search-expand input').focus();
            }, 300);
	});

/*  Equal heights
/* -------------------------------------------- */
	$(function() {
   	 	$('.equalheight').matchHeight();
	});

		$(function() {
   	 	$('.featuredheight').matchHeight();
	});
/*  Scroll to top
/* ------------------------------------ */
	$('a#back-to-top').click(function() {
		$('html, body').animate({scrollTop:0},'slow');
		return false;
	});
	
/*  Tabs widget
/* ------------------------------------ */	
	(function() {
		var $tabsNav       = $('.blogsetup-tabs-nav'),
			$tabsNavLis    = $tabsNav.children('li'),
			$tabsContainer = $('.blogsetup-tabs-container');

		$tabsNav.each(function() {
			var $this = $(this);
			$this.next().children('.blogsetup-tab').stop(true,true).hide()
			.siblings( $this.find('a').attr('href') ).show();
			$this.children('li').first().addClass('active').stop(true,true).show();
		});

		$tabsNavLis.on('click', function(e) {
			var $this = $(this);

			$this.siblings().removeClass('active').end()
			.addClass('active');
			
			$this.parent().next().children('.blogsetup-tab').stop(true,true).hide()
			.siblings( $this.find('a').attr('href') ).fadeIn();
			e.preventDefault();
		}).children( window.location.hash ? 'a[href=' + window.location.hash + ']' : 'a:first' ).trigger('click');

	})();
	
/*  Comments / pingbacks tabs
/* ------------------------------------ */	
    $(".comment-tabs li").click(function() {
        $(".comment-tabs li").removeClass('active');
        $(this).addClass("active");
        $(".comment-tab").hide();
        var selected_tab = $(this).find("a").attr("href");
        $(selected_tab).fadeIn();
        return false;
    });

/*  Table odd row class
/* ------------------------------------ */
	$('table tr:odd').addClass('alt');

/*  Sidebar collapse
/* ------------------------------------ */
	$('body').addClass('s1-collapse');
	$('body').addClass('s2-collapse');
	
	$('.s1 .sidebar-toggle').click(function(){
		$('body').toggleClass('s1-collapse').toggleClass('s1-expand');
		if ($('body').is('.s2-expand')) { 
			$('body').toggleClass('s2-expand').toggleClass('s2-collapse');
		}
	});
	$('.s2 .sidebar-toggle').click(function(){
		$('body').toggleClass('s2-collapse').toggleClass('s2-expand');
		if ($('body').is('.s1-expand')) { 
			$('body').toggleClass('s1-expand').toggleClass('s1-collapse');
		}
	});



/*  Fitvids
/* ------------------------------------ */
	function responsiveVideo() {
			if ( $().fitVids ) {
				$('#wrapper').fitVids();
			}	
		}
		
	responsiveVideo();
	
/*  Slick
/* ------------------------------------ */

$('.featured-posts').slick({
  dots: false,
  infinite: false,
  speed: 300,
  slidesToShow: 3,
  slidesToScroll: 3,
  responsive: [
    {
      breakpoint: 950,
      settings: {
        slidesToShow: 2,
        slidesToScroll: 2,
        infinite: true,
      }
    },
    {
      breakpoint: 600,
      settings: {
        slidesToShow: 1,
        slidesToScroll: 1
      }
    }
    // You can unslick at a given breakpoint now by adding:
    // settings: "unslick"
    // instead of a settings object
  ]
});
	
/*  Mobile menu smooth toggle height
/* ------------------------------------ */	
	$('.nav-toggle').on('click', function() {
		slide($('.nav-wrap .nav', $(this).parent()));
	});
	 
	function slide(content) {
		var wrapper = content.parent();
		var contentHeight = content.outerHeight(true);
		var wrapperHeight = wrapper.height();

	 
		wrapper.toggleClass('expand');
		if ( (wrapper.hasClass('expand')) && ($(wrapper).parent().attr('id') == 'nav-header') ) {
		setTimeout(function() {
			wrapper.addClass('transition').css('height', contentHeight);
			$('#nav-subheader .nav-wrap').css('height',0);
			$('#nav-subheader .nav-wrap').removeClass('expand');
			$('#nav-subheader .nav-toggle').css('top', - (contentHeight + 12)  );
			$('#nav-subheader').css('top', contentHeight + parseInt(6) );
	
		}, 10);
	
	} else if ( (wrapper.hasClass('expand')) && ($(wrapper).parent().attr('id') == 'nav-subheader') ) {
		setTimeout(function() {
			wrapper.addClass('transition').css('height', contentHeight);
			$('#nav-header .nav-wrap').css('height',0);
 			if ($('#nav-header .nav-wrap').hasClass('expand')) {
 				$('#nav-subheader').css('top',0);
 				$('#nav-header .nav-wrap').removeClass('expand');
 				$('#nav-subheader .nav-toggle').css('top', '-12px') ;
 			}

		}, 10);
	} else if ( (wrapper.hasClass('expand')) && ($(wrapper).parent().attr('id') == 'nav-topbar') ) {
		setTimeout(function() {
			wrapper.addClass('transition').css('height', contentHeight);

		}, 10);
	} else if ( (wrapper.hasClass('expand')) && ($(wrapper).parent().attr('id') == 'nav-footer') ) {
		setTimeout(function() {
			wrapper.addClass('transition').css('height', contentHeight);

		}, 10);
	}
	

	else {
		setTimeout(function() {
			wrapper.css('height', wrapperHeight);
			setTimeout(function() {
			wrapper.addClass('transition').css('height', 0);
			$('#nav-subheader').css('top',0);
			$('#nav-subheader .nav-toggle').css('top', '-12px') ;
			}, 10);
		}, 10);
	}
	 
	wrapper.one('transitionEnd webkitTransitionEnd transitionend oTransitionEnd msTransitionEnd', function() {
		if(wrapper.hasClass('open')) {
			wrapper.removeClass('transition').css('height', 'auto');
		}
	});
	}
	
});

//Not the most effecient JS plugin, but you get the idea. Feel free to improve for your needs.


(function( $ ) {
	$.fn.clipPath = function() {
		
		this.filter('[data-clipPath]').each(function(i) {
			
			//get IMG attributes
			var maskPath = $(this).attr('data-clipPath');
			var maskPathRect = $(this).attr('data-clipPathRect');
			var maskSrc = $(this).attr('src');
			var maskWidth = $(this).attr('width');
			var maskHeight = $(this).attr('height');
			var vbW = $(this).attr('vbw');
 			var vbH = $(this).attr('vbh');
			var maskAlt = $(this).attr('alt');
			var maskTitle = $(this).attr('title');
			var imgID = $(this).attr('id');
			var rectID = $(this).attr('rectid');
			var uniqueID = i;
			var urlPath = $(location).attr('href');
			
			//build SVG from our IMG attributes & path coords.
			
			var svg = $('<svg version="1.1" xmlns="http://www.w3.org/2000/svg" class="svgMask" width="'
				+maskWidth+'" height="'
				+maskHeight+'" viewBox="0 0 '
				+vbW+' '
				+vbH+'"><defs><clipPath id="maskID'
				+uniqueID+''+imgID+'"><path d="'
				+maskPath+'"/></clipPath><clipPath id="maskID'
				+uniqueID+''
				+imgID+''
				+rectID+'"><path d="'
				+maskPathRect+'"/></clipPath> </defs> <title>'
				+maskTitle+'</title> <desc>'
				+maskAlt+'</desc> <rect id="'
				+rectID+'" clip-path="url('
				+urlPath+'#maskID'
				+uniqueID+''
				+imgID+''
				+rectID+')" width="100%" height="100%"></rect><image id="'
				+imgID+'" clip-path="url('
				+urlPath+'#maskID'
				+uniqueID+''
				+imgID+')" width="'
				+maskWidth+'" height="'
				+maskHeight+'" xlink:href="'
				+maskSrc+'"/></svg>');
				
			//swap original IMG with SVG
			$(this).replaceWith(svg);

			//clean up
			 maskPath = '', maskSrc = '', maskAlt = '', maskTitle = '', uniqueID = '', svg = '';
			
		});
 
		return this;

	};
 
}( jQuery ));

//USAGE:
jQuery(document).ready(function($){
$('.featuredclip img')
.attr('data-clipPath','     M96 111 L146 111 L146 4 L4 4 L4 111 L54 111 L75 141 Z')
.attr('data-clipPathRect','M100 115 L150 115 L150 0 L0 0 L0 115 L50 115 L75 150 Z')
.attr('width','100%')
.attr('height','100%')
.attr('vbw','150')
.attr('vbh','150')
.attr('id','alpha')
.attr('rectid','omega')
.clipPath(); 
});

jQuery(document).ready(function($){
$('.mainclip img')
.attr('data-clipPath','    M686 286 L716 286 L716 14 L4 14 L4 286 L655 286 L636 335 Z')
.attr('data-clipPathRect','M689 290 L720 290 L720 10 L0 10 L0 290 L649 290 L633 340 Z')
.attr('width','100%')
.attr('height','100%')
.attr('vbw','720')
.attr('vbh','340')
.attr('id','bravo')
.attr('rectid','gamma')
.clipPath();
});

//Controls sub-menu animations
jQuery(document).ready(function($) {
$('.featured-posts').fadeIn(350);
$('.sub-menu').hide();
var timer;
$('.nav li, ul.sub-menu').hover(function() {
    $(this).children('ul.sub-menu').slideDown('fast'); 
    },
    function() {
    var that = $(this).children('ul.sub-menu');
    setTimeout(function(){that.hide();},500);
    }
 	);
});


